function x=gtsp0(Pkp)
% generate a permutation from P_t
% generation using node transitions
[n,m]=size(Pkp); % n==m
x(1)=1;
Pkp=Pkp+1e-5;
for k=1:(n-1),
  Pkp(:,x(k))=zeros(n,1);
  for i=1:n,
	if(sum(Pkp(i,:)~=0)),
	  Pkp(i,:)=Pkp(i,:)/sum(Pkp(i,:)); 
	end
  end
  r=rand(1);
  cc=0;
  c=0;
  while(r>cc && c<n),
	c=c+1;
	cc=cc+Pkp(x(k),c);
  end
  x(k+1)=c;
end
