% griewank function
% minimum = 0;  X = [0...0]

function Y = griewank(X)
% Y is a column vector, X is a matrix, each row of X is a sample

dim = size(X,2);  % dimension of the problem, i.e., length of each sample

Y=1/4000*sum((X(:,1:dim)).^2, 2)- prod(cos(X(:,1:dim)./sqrt(repmat([1:1:dim],size(X,1),1))),2)+1;
Y=Y+1;