
% multinomial distribution sampler
% p is a row vector of parameters, p=[p_1,p_2,...,p_n] with \sum(p_i)=1;
% k is the sample size

function r = multirnd(p,n,k)

m = length(p)/n;

for i=1:n
p_cdf((i-1)*m+1:(i-1)*m+m) = cumsum(p((i-1)*m+1:(i-1)*m+m));
end

%r = zeros(n,1);
random_vals = rand(k,n);

for j = 1:k
    for i=1:n
    index = min(find(random_vals(j,i) <= p_cdf((i-1)*m+1:(i-1)*m+m)));
    r(j,i) = index;
    end
end