% weighted sphere function
% minimum = 0;  X = [0...0]

function Y = sphere(X)
% Y is a column vector, X is a matrix, each row of X is a sample

dim = size(X,2);  % dimension of the problem, i.e., length of each sample

Y=sum(repmat([1:1:dim],size(X,1),1).*X(:,1:dim).^2,2);
Y=Y+1;
